#include <stdio.h>
#include <stdlib.h>

#include "f2c.h"

/* Common Block Declarations */

struct {
    double r__[32]  /* was [16][2] */, deltr[32]  /* was [16][2] */;
    int ni;
} deltr_;

#define deltr_1 deltr_

int main(void)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    double cos(double), sin(double);

    /* Local variables */
    extern int f_c();
    static double h__;
    static int j, m;
    static double q;
    static int s;
    static double y[2], h0;
    static int k0;
    static double x1, dy[2], xk, xn, yn[2], yt[2], rab[535], dyn[2], dyt[2];
    extern int de89d_c( );
    static double dely[2];
    static int imax;
    static double deldy[2];
    static int iniap0;
    extern int f2trea_c();
    static int iniapr;

    deltr_1.ni = 16;
    m = 2;
    q = .5;
    xn = 0.f;
    yn[0] = cos(q) + 3.;
    yn[1] = -sin(q) + 2.;
    dyn[0] = q * 2. * sin(q);
    dyn[1] = q * 2. * cos(q);
    xk = 1.;
    h0 = .5;
    x1 = xk * 2. - 1.;
    yt[0] = cos(q * x1) + 3.;
    yt[1] = sin(q * x1) + 2.;
    dyt[0] = q * -2. * sin(q * x1);
    dyt[1] = q * 2. * cos(q * x1);
    k0 = 11;
    imax = 13;

    for (iniap0 = 1; iniap0 <= 2; ++iniap0) {
	iniapr = iniap0;
	h__ = h0;

	de89d_c((U_fp)f_c, (U_fp)f2trea_c, &m, &xn, yn, dyn, &xk, &k0, &iniapr,
                &imax, &h__, y, dy, rab);

	dely[0] = yt[0] - y[0];
	dely[1] = yt[1] - y[1];
	deldy[0] = dyt[0] - dy[0];
	deldy[1] = dyt[1] - dy[1];

   printf("\n ------------------------------------------------------------\n");

    printf("\n h0=%21.14e k0=%3i iniapr= %1i imax=%3i \n\n",h0,k0,iniapr,imax);

    printf("\n y= %21.14e %21.14e\n", y[0], y[1]);
    printf("\n yt= %21.14e %21.14e\n",yt[0], yt[1]);
    printf("\n dely= %23.14e %21.14e\n\n", dely[0], dely[1]);

    printf("\n dy= %21.14e %21.14e\n",dy[0], dy[1]);
    printf("\n dyt= %21.14e %21.14e\n",dyt[0], dyt[1]);
    printf("\n deldy= %23.14e %21.14e \n", deldy[0], deldy[1]);

    printf("\n ***********************************************************\n");

/* _____________________________ */

	for (s = 1; s <= 2; ++s) {

            printf("\n\n         Phase motion  for %i segment ", s);
            printf("\n\npoint         distance                 error \n");

	    i__1 = deltr_1.ni;
	    for (j = 1; j <= i__1; ++j) {

    printf("\n %i %24.14e %24.14e ", j, deltr_1.r__[j + (s << 4) - 17], deltr_1.deltr[j + (s << 4) - 17] );
	    }
	}
    printf("\n\n ***********************************************************\n");
/* _____________________________ */

    }
    printf("\n");

    return 0;
} /* main */


/* Subroutine */ int f_c(double *x, double *y, double *dy,
	double *z__, int *m)
{
    /* System generated locals */
    double d__1;

    /* Builtin functions */
    double exp(double);

    /* Local variables */
    static real q;

    /* Parameter adjustments */
    --z__;
    --dy;
    --y;

    /* Function Body */
    q = .5f;
/* Computing 2nd power */
    d__1 = (1. - exp(3. - y[1] + dy[2] * .5 / q)) / (*x + 1.);
    z__[1] = q * -2. * dy[2] - d__1 * d__1;
/* Computing 2nd power */
    d__1 = dy[2] - q * 2. * (y[1] - 3.);
    z__[2] = q * 2. * dy[1] - d__1 * d__1;
    return 0;
} /* f_c */


 int f2trea_c(int *s, double *xi, double *xe,
	double *y, double *dy, double *ay, double *ady,
	double *ad2y, int *m, int *kp1, int *kp2, int *kp3)
{
    /* System generated locals */
    int ay_dim1, ay_offset, ady_dim1, ady_offset, ad2y_dim1, ad2y_offset,
	    i__1;
    double d__1, d__2;

    /* Builtin functions */
    double sqrt(double);

    /* Local variables */
    static int j;
    static double x, bk[4]	/* was [2][2] */, hi, yi[2];
    extern  int de70dc_c( );

    /* Parameter adjustments */
    --dy;
    --y;
    ad2y_dim1 = *m;
    ad2y_offset = 1 + ad2y_dim1;
    ad2y -= ad2y_offset;
    ady_dim1 = *m;
    ady_offset = 1 + ady_dim1;
    ady -= ady_offset;
    ay_dim1 = *m;
    ay_offset = 1 + ay_dim1;
    ay -= ay_offset;

    /* Function Body */
    hi = (*xe - *xi) / (double) deltr_1.ni;
    x = *xi;
    i__1 = deltr_1.ni;
    for (j = 1; j <= i__1; ++j) {
	x += hi;

/* ------CALCULATION OF SOLUTION YI AT POINT X (BY ALGORITHM CLENSHAW, */
/* -------    KP2 - POWER (DEGREE) OF POLYNOMIAL ) */

	de70dc_c(m, kp2, &x, &ay[ay_offset], yi, bk);

/* Computing 2nd power */
	d__1 = yi[0] - 3.;
/* Computing 2nd power */
	d__2 = yi[1] - 2.;
	deltr_1.r__[j + (*s << 4) - 17] = sqrt(d__1 * d__1 + d__2 * d__2);
	deltr_1.deltr[j + (*s << 4) - 17] = 1. - deltr_1.r__[j + (*s << 4) -
		17];
/* L10: */
    }
    return 0;
} /* f2trea_c */
